Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePhotoElectricModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePhotoElectricModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePhotoElectricModel.cc	(revision 1055)
@@ -24,7 +24,20 @@
 // ********************************************************************
 //
-// $Id: G4LivermorePhotoElectricModel.cc,v 1.1 2008/10/30 14:16:35 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
-//
+// $Id: G4LivermorePhotoElectricModel.cc,v 1.7 2009/04/18 18:29:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+//
+// Author: Sebastien Inserti
+//         30 October 2008
+//
+// History:
+// --------
+// 15 Apr 2009   V Ivanchenko Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+//                  - remove GetMeanFreePath method and table
+//                  - simplify sampling of deexcitation by using cut in energy
+//                  - added protection against numerical problem in energy sampling 
+//                  - use G4ElementSelector
 
 #include "G4LivermorePhotoElectricModel.hh"
@@ -38,17 +51,14 @@
 G4LivermorePhotoElectricModel::G4LivermorePhotoElectricModel(const G4ParticleDefinition*,
                                              const G4String& nam)
-:G4VEmModel(nam),isInitialised(false)
-{
-  lowEnergyLimit = 250 * eV; // SI - Could be 10 eV ?
+:G4VEmModel(nam),isInitialised(false),meanFreePathTable(0),
+ crossSectionHandler(0),shellCrossSectionHandler(0),ElectronAngularGenerator(0)
+{
+  lowEnergyLimit = 250 * eV; 
   highEnergyLimit = 100 * GeV;
-  SetLowEnergyLimit(lowEnergyLimit);
+  //  SetLowEnergyLimit(lowEnergyLimit);
   SetHighEnergyLimit(highEnergyLimit);
-  
-  G4cout << "Livermore Compton is constructed " << G4endl
-         << "Energy range: "
-         << lowEnergyLimit / keV << " keV - "
-         << highEnergyLimit / GeV << " GeV"
-         << G4endl;
- 
+
+  ActivateAuger(false);
+   
   verboseLevel= 0;
   // Verbosity scale:
@@ -58,4 +68,11 @@
   // 3 = calculation of cross sections, file openings, sampling of atoms
   // 4 = entering in methods
+  if(verboseLevel>0) {
+    G4cout << "Livermore PhotoElectric is constructed " << G4endl
+	   << "Energy range: "
+	   << lowEnergyLimit / eV << " eV - "
+	   << highEnergyLimit / GeV << " GeV"
+	   << G4endl;
+  }
 }
 
@@ -64,38 +81,30 @@
 G4LivermorePhotoElectricModel::~G4LivermorePhotoElectricModel()
 {  
-  delete meanFreePathTable;
-  delete crossSectionHandler;
-  delete shellCrossSectionHandler;
-  delete ElectronAngularGenerator;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-void G4LivermorePhotoElectricModel::Initialise(const G4ParticleDefinition* particle,
-                                       const G4DataVector& cuts)
+  if (crossSectionHandler) delete crossSectionHandler;
+  if (shellCrossSectionHandler) delete shellCrossSectionHandler;
+  if (ElectronAngularGenerator) delete ElectronAngularGenerator;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+void 
+G4LivermorePhotoElectricModel::Initialise(const G4ParticleDefinition*,
+					  const G4DataVector&)
 {
   if (verboseLevel > 3)
     G4cout << "Calling G4LivermorePhotoElectricModel::Initialise()" << G4endl;
 
-  InitialiseElementSelectors(particle,cuts);
-
-  // Energy limits
-  
-  if (LowEnergyLimit() < lowEnergyLimit)
+  if (crossSectionHandler)
   {
-      G4cout << "G4LivermorePhotoElectricModel: low energy limit increased from " <<
-        LowEnergyLimit()/eV << " eV to " << lowEnergyLimit << " eV" << 
-	G4endl;
-      SetLowEnergyLimit(lowEnergyLimit);
-  }
- 
-  if (HighEnergyLimit() > highEnergyLimit)
+    crossSectionHandler->Clear();
+    delete crossSectionHandler;
+  }
+  
+  if (shellCrossSectionHandler)
   {
-      G4cout << "G4LivermorePhotoElectricModel: high energy limit decreased from " <<
-        HighEnergyLimit()/GeV << " GeV to " << highEnergyLimit << " GeV" 
-	     << G4endl;
-      SetHighEnergyLimit(highEnergyLimit);
-  }
-
+    shellCrossSectionHandler->Clear();
+    delete shellCrossSectionHandler;
+  }
+  
   // Read data tables for all materials
   
@@ -105,7 +114,4 @@
   crossSectionHandler->LoadData(crossSectionFile);
 
-  meanFreePathTable = 0;
-  meanFreePathTable = crossSectionHandler->BuildMeanFreePathForMaterials();
-
   shellCrossSectionHandler = new G4CrossSectionHandler();
   shellCrossSectionHandler->Clear();
@@ -113,26 +119,26 @@
   shellCrossSectionHandler->LoadShellData(shellCrossSectionFile);
   
-  // SI - Buggy default ?
+  // SI - Simple generator is buggy
   //generatorName = "geant4.6.2";
   //ElectronAngularGenerator = new G4PhotoElectricAngularGeneratorSimple("GEANTSimpleGenerator");              // default generator
-
-  //
-  
+  ElectronAngularGenerator = 
+    new G4PhotoElectricAngularGeneratorSauterGavrila("GEANTSauterGavrilaGenerator");        
+
+  //  
   if (verboseLevel > 2) 
     G4cout << "Loaded cross section files for Livermore PhotoElectric model" << G4endl;
 
-  G4cout << "Livermore PhotoElectric model is initialized " << G4endl
-         << "Energy range: "
-         << LowEnergyLimit() / keV << " keV - "
-         << HighEnergyLimit() / GeV << " GeV"
-         << G4endl;
+  //  InitialiseElementSelectors(particle,cuts);
+
+  if (verboseLevel > 0) { 
+    G4cout << "Livermore PhotoElectric model is initialized " << G4endl
+	   << "Energy range: "
+	   << LowEnergyLimit() / eV << " eV - "
+	   << HighEnergyLimit() / GeV << " GeV"
+	   << G4endl;
+  }
 
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
-
+  fParticleChange = GetParticleChangeForGamma();
   isInitialised = true;
 }
@@ -147,5 +153,9 @@
 {
   if (verboseLevel > 3)
-    G4cout << "Calling ComputeCrossSectionPerAtom() of G4LivermorePhotoElectricModel" << G4endl;
+    G4cout << "Calling ComputeCrossSectionPerAtom() of G4LivermorePhotoElectricModel" 
+	   << G4endl;
+
+  if (GammaEnergy < lowEnergyLimit || GammaEnergy > highEnergyLimit)
+    return 0;
 
   G4double cs = crossSectionHandler->FindValue(G4int(Z), GammaEnergy);
@@ -155,9 +165,10 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-void G4LivermorePhotoElectricModel::SampleSecondaries(std::vector<G4DynamicParticle*>* fvect,
-					      const G4MaterialCutsCouple* couple,
-					      const G4DynamicParticle* aDynamicGamma,
-					      G4double,
-					      G4double)
+void 
+G4LivermorePhotoElectricModel::SampleSecondaries(std::vector<G4DynamicParticle*>* fvect,
+						 const G4MaterialCutsCouple* couple,
+						 const G4DynamicParticle* aDynamicGamma,
+						 G4double,
+						 G4double)
 {
 
@@ -172,17 +183,23 @@
   G4double photonEnergy = aDynamicGamma->GetKineticEnergy();
   
+  // kill incident photon
+  fParticleChange->SetProposedKineticEnergy(0.);
+  fParticleChange->ProposeTrackStatus(fStopAndKill);   
+
+  // low-energy gamma is absorpted by this process
   if (photonEnergy <= lowEnergyLimit)
     {
-      fParticleChange->ProposeTrackStatus(fStopAndKill);
-      fParticleChange->SetProposedKineticEnergy(0.);
       fParticleChange->ProposeLocalEnergyDeposit(photonEnergy);
-      // SI - IS THE FOLLOWING RETURN NECESSARY ?
-      return ;
+      return;
     }
  
-  G4ThreeVector photonDirection = aDynamicGamma->GetMomentumDirection(); // Returns the normalized direction of the momentum
+  // Returns the normalized direction of the momentum
+  G4ThreeVector photonDirection = aDynamicGamma->GetMomentumDirection(); 
 
   // Select randomly one element in the current material
-  G4int Z = crossSectionHandler->SelectRandomAtom(couple,photonEnergy);
+  //  G4int Z = crossSectionHandler->SelectRandomAtom(couple,photonEnergy);
+  const G4ParticleDefinition* particle =  aDynamicGamma->GetDefinition();
+  const G4Element* elm = SelectRandomAtom(couple->GetMaterial(),particle,photonEnergy);
+  G4int Z = (G4int)elm->GetZ();
 
   // Select the ionised shell in the current atom according to shell cross sections
@@ -195,11 +212,4 @@
   G4int shellId = shell->ShellId();
 
-  // Create lists of pointers to DynamicParticles (photons and electrons)
-  // (Is the electron vector necessary? To be checked)
-  std::vector<G4DynamicParticle*>* photonVector = 0;
-  std::vector<G4DynamicParticle*> electronVector;
-
-  G4double energyDeposit = 0.0;
-
   // Primary outcoming electron
   G4double eKineticEnergy = photonEnergy - bindingEnergy;
@@ -209,26 +219,17 @@
   if (eKineticEnergy > 0.)
     {
-      // SI - Removed safety
-      
-      // Generate the electron only if with large enough range w.r.t. cuts and safety
-      //G4double safety = aStep.GetPostStepPoint()->GetSafety();
-
-      //if (rangeTest->Escape(G4Electron::Electron(),couple,eKineticEnergy,safety))
-	{
-
-	  // Calculate direction of the photoelectron
-	  G4ThreeVector gammaPolarization = aDynamicGamma->GetPolarization();
-	  G4ThreeVector electronDirection = ElectronAngularGenerator->GetPhotoElectronDirection(photonDirection,eKineticEnergy,gammaPolarization,shellId);
-
-	  // The electron is created ...
-	  G4DynamicParticle* electron = new G4DynamicParticle (G4Electron::Electron(),
-							       electronDirection,
-							       eKineticEnergy);
-	  electronVector.push_back(electron);
-	}
-      /*else
-	{
-	  energyDeposit += eKineticEnergy;
-	}*/
+      // Calculate direction of the photoelectron
+      G4ThreeVector gammaPolarization = aDynamicGamma->GetPolarization();
+      G4ThreeVector electronDirection = 
+	ElectronAngularGenerator->GetPhotoElectronDirection(photonDirection,
+							    eKineticEnergy,
+							    gammaPolarization,
+							    shellId);
+
+      // The electron is created ...
+      G4DynamicParticle* electron = new G4DynamicParticle (G4Electron::Electron(),
+							   electronDirection,
+							   eKineticEnergy);
+      fvect->push_back(electron);
     }
   else
@@ -237,88 +238,54 @@
     }
 
-  G4int nElectrons = electronVector.size();
-  size_t nTotPhotons = 0;
-  G4int nPhotons=0;
-  const G4ProductionCutsTable* theCoupleTable=
-        G4ProductionCutsTable::GetProductionCutsTable();
-
-  size_t index = couple->GetIndex();
-  G4double cutg = (*(theCoupleTable->GetEnergyCutsVector(0)))[index];
-  cutg = std::min(cutForLowEnergySecondaryPhotons,cutg);
-  
-  G4double cute = (*(theCoupleTable->GetEnergyCutsVector(1)))[index];
-  cute = std::min(cutForLowEnergySecondaryPhotons,cute);
-
-  G4DynamicParticle* aPhoton;
-
-  // Generation of fluorescence
-  // Data in EADL are available only for Z > 5
-  // Protection to avoid generating photons in the unphysical case of
-  // shell binding energy > photon energy
-  if (Z > 5  && (bindingEnergy > cutg || bindingEnergy > cute))
-    {
-      photonVector = deexcitationManager.GenerateParticles(Z,shellId);
-      nTotPhotons = photonVector->size();
-      for (size_t k=0; k<nTotPhotons; k++)
-	{
-	  aPhoton = (*photonVector)[k];
-	  if (aPhoton)
-	    {
-              G4double itsCut = cutg;
-              if(aPhoton->GetDefinition() == G4Electron::Electron()) itsCut = cute;
-	      G4double itsEnergy = aPhoton->GetKineticEnergy();
-
-	      if (itsEnergy > itsCut && itsEnergy <= bindingEnergy)
-		{
-		  nPhotons++;
-		  // Local energy deposit is given as the sum of the
-		  // energies of incident photons minus the energies
-		  // of the outcoming fluorescence photons
-		  bindingEnergy -= itsEnergy;
-
-		}
-	      else
-		{
-                  delete aPhoton;
-                  (*photonVector)[k] = 0;
-                }
-	    }
-	}
-    }
-
-  energyDeposit += bindingEnergy;
-
-  // Final state
-  
-  for (G4int l = 0; l<nElectrons; l++ )
-    {
-      aPhoton = electronVector[l];
-      if(aPhoton) {
-        fvect->push_back(aPhoton);
+  // deexcitation
+  if(DeexcitationFlag() && Z > 5) {
+
+    const G4ProductionCutsTable* theCoupleTable=
+      G4ProductionCutsTable::GetProductionCutsTable();
+
+    size_t index = couple->GetIndex();
+    G4double cutg = (*(theCoupleTable->GetEnergyCutsVector(0)))[index];
+    G4double cute = (*(theCoupleTable->GetEnergyCutsVector(1)))[index];
+
+    // Generation of fluorescence
+    // Data in EADL are available only for Z > 5
+    // Protection to avoid generating photons in the unphysical case of
+    // shell binding energy > photon energy
+    if (bindingEnergy > cutg || bindingEnergy > cute)
+      {
+	G4DynamicParticle* aPhoton;
+	deexcitationManager.SetCutForSecondaryPhotons(cutg);
+	deexcitationManager.SetCutForAugerElectrons(cute);
+ 
+	std::vector<G4DynamicParticle*>* photonVector = 
+	  deexcitationManager.GenerateParticles(Z,shellId);
+	size_t nTotPhotons = photonVector->size();
+	for (size_t k=0; k<nTotPhotons; k++)
+	  {
+	    aPhoton = (*photonVector)[k];
+	    if (aPhoton)
+	      {
+		G4double itsEnergy = aPhoton->GetKineticEnergy();
+		if (itsEnergy <= bindingEnergy)
+		  {
+		    // Local energy deposit is given as the sum of the
+		    // energies of incident photons minus the energies
+		    // of the outcoming fluorescence photons
+		    bindingEnergy -= itsEnergy;
+		    fvect->push_back(aPhoton);
+		  }
+		else
+		  {
+		    // abnormal case of energy non-conservation
+		    delete aPhoton;
+		    (*photonVector)[k] = 0;
+		  }
+	      }
+	  }
+	delete photonVector;
       }
-    }
-  for ( size_t ll = 0; ll < nTotPhotons; ll++)
-    {
-      aPhoton = (*photonVector)[ll];
-      if(aPhoton) {
-        fvect->push_back(aPhoton);
-      }
-    }
-
-  delete photonVector;
-
-  if (energyDeposit < 0)
-    {
-      G4cout << "WARNING - "
-	     << "G4LowEnergyPhotoElectric::PostStepDoIt - Negative energy deposit"
-	     << G4endl;
-      energyDeposit = 0;
-    }
-
-  // kill incident photon
-  fParticleChange->ProposeMomentumDirection( 0., 0., 0. );
-  fParticleChange->SetProposedKineticEnergy(0.);
-  fParticleChange->ProposeTrackStatus(fStopAndKill);   
-  fParticleChange->ProposeLocalEnergyDeposit(energyDeposit);
+  }
+  // excitation energy left
+  fParticleChange->ProposeLocalEnergyDeposit(bindingEnergy);
 }
 
@@ -348,7 +315,8 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-void G4LivermorePhotoElectricModel::SetAngularGenerator(G4VPhotoElectricAngularDistribution* distribution)
-{
-  ElectronAngularGenerator = distribution;
+void 
+G4LivermorePhotoElectricModel::SetAngularGenerator(G4VPhotoElectricAngularDistribution* dist)
+{
+  ElectronAngularGenerator = dist;
   ElectronAngularGenerator->PrintGeneratorInformation();
 }
@@ -361,5 +329,6 @@
     {
       delete ElectronAngularGenerator;
-      ElectronAngularGenerator = new G4PhotoElectricAngularGeneratorSimple("GEANT4LowEnergySimpleGenerator");
+      ElectronAngularGenerator = 
+	new G4PhotoElectricAngularGeneratorSimple("GEANT4LowEnergySimpleGenerator");
       generatorName = name;
     }
@@ -367,5 +336,6 @@
     {
       delete ElectronAngularGenerator;
-      ElectronAngularGenerator = new G4PhotoElectricAngularGeneratorSauterGavrila("GEANT4SauterGavrilaGenerator");
+      ElectronAngularGenerator = 
+	new G4PhotoElectricAngularGeneratorSauterGavrila("GEANT4SauterGavrilaGenerator");
       generatorName = name;
     }
@@ -373,5 +343,6 @@
     {
       delete ElectronAngularGenerator;
-      ElectronAngularGenerator = new G4PhotoElectricAngularGeneratorPolarized("GEANT4LowEnergyPolarizedGenerator");
+      ElectronAngularGenerator = 
+	new G4PhotoElectricAngularGeneratorPolarized("GEANT4LowEnergyPolarizedGenerator");
       generatorName = name;
     }
@@ -384,26 +355,2 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-G4double G4LivermorePhotoElectricModel::GetMeanFreePath(const G4Track& track,
-						   G4double, // previousStepSize
-					       G4ForceCondition*)
-{
-  const G4DynamicParticle* photon = track.GetDynamicParticle();
-  G4double energy = photon->GetKineticEnergy();
-  G4Material* material = track.GetMaterial();
-  //  size_t materialIndex = material->GetIndex();
-
-  G4double meanFreePath = DBL_MAX;
-
-  //  if (energy > highEnergyLimit) 
-  //    meanFreePath = meanFreePathTable->FindValue(highEnergyLimit,materialIndex);
-  //  else if (energy < lowEnergyLimit) meanFreePath = DBL_MAX;
-  //  else meanFreePath = meanFreePathTable->FindValue(energy,materialIndex);
-
-  G4double cross = shellCrossSectionHandler->ValueForMaterial(material,energy);
-  if(cross > 0.0) meanFreePath = 1.0/cross;
-
-  return meanFreePath;
-}
-
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedComptonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedComptonModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedComptonModel.cc	(revision 1055)
@@ -24,7 +24,17 @@
 // ********************************************************************
 //
-// $Id: G4LivermorePolarizedComptonModel.cc,v 1.1 2008/10/30 14:16:35 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4LivermorePolarizedComptonModel.cc,v 1.6 2009/05/03 08:29:55 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
+// History:
+// --------
+// 02 May 2009   S Incerti as V. Ivanchenko proposed in G4LivermoreComptonModel.cc
+//
+// Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+//                  - remove GetMeanFreePath method and table
+//                  - added protection against numerical problem in energy sampling 
+//                  - use G4ElementSelector
 
 #include "G4LivermorePolarizedComptonModel.hh"
@@ -38,9 +48,9 @@
 G4LivermorePolarizedComptonModel::G4LivermorePolarizedComptonModel(const G4ParticleDefinition*,
                                              const G4String& nam)
-:G4VEmModel(nam),isInitialised(false)
-{
-  lowEnergyLimit = 250 * eV; // SI - Could be 10 eV ?
+:G4VEmModel(nam),isInitialised(false),meanFreePathTable(0),scatterFunctionData(0),crossSectionHandler(0)
+{
+  lowEnergyLimit = 250 * eV; 
   highEnergyLimit = 100 * GeV;
-  SetLowEnergyLimit(lowEnergyLimit);
+  //SetLowEnergyLimit(lowEnergyLimit);
   SetHighEnergyLimit(highEnergyLimit);
   
@@ -53,10 +63,11 @@
   // 4 = entering in methods
 
+  if( verboseLevel>0 ) { 
   G4cout << "Livermore Polarized Compton is constructed " << G4endl
          << "Energy range: "
-         << lowEnergyLimit / keV << " keV - "
+         << lowEnergyLimit / eV << " eV - "
          << highEnergyLimit / GeV << " GeV"
          << G4endl;
-
+  }
 }
 
@@ -65,7 +76,7 @@
 G4LivermorePolarizedComptonModel::~G4LivermorePolarizedComptonModel()
 {  
-  delete meanFreePathTable;
-  delete crossSectionHandler;
-  delete scatterFunctionData;
+  if (meanFreePathTable)   delete meanFreePathTable;
+  if (crossSectionHandler) delete crossSectionHandler;
+  if (scatterFunctionData) delete scatterFunctionData;
 }
 
@@ -78,21 +89,9 @@
     G4cout << "Calling G4LivermorePolarizedComptonModel::Initialise()" << G4endl;
 
-  InitialiseElementSelectors(particle,cuts);
-
-  // Energy limits
-  
-  if (LowEnergyLimit() < lowEnergyLimit)
-    {
-      G4cout << "G4LivermorePolarizedComptonModel: low energy limit increased from " << 
-	LowEnergyLimit()/eV << " eV to " << lowEnergyLimit << " eV" << G4endl;
-      SetLowEnergyLimit(lowEnergyLimit);
-    }
-
-  if (HighEnergyLimit() > highEnergyLimit)
-    {
-      G4cout << "G4LivermorePolarizedComptonModel: high energy limit decreased from " << 
-	HighEnergyLimit()/GeV << " GeV to " << highEnergyLimit << " GeV" << G4endl;
-      SetHighEnergyLimit(highEnergyLimit);
-    }
+  if (crossSectionHandler)
+  {
+    crossSectionHandler->Clear();
+    delete crossSectionHandler;
+  }
 
   // Reading of data files - all materials are read
@@ -116,23 +115,21 @@
   shellData.LoadData(file);
 
-  //
   if (verboseLevel > 2) 
     G4cout << "Loaded cross section files for Livermore Polarized Compton model" << G4endl;
 
-  G4cout << "Livermore Polarized Compton model is initialized " << G4endl
+  InitialiseElementSelectors(particle,cuts);
+
+  if(  verboseLevel>0 ) { 
+    G4cout << "Livermore Polarized Compton model is initialized " << G4endl
          << "Energy range: "
-         << LowEnergyLimit() / keV << " keV - "
+         << LowEnergyLimit() / eV << " eV - "
          << HighEnergyLimit() / GeV << " GeV"
          << G4endl;
-
+  }
+  
   //
     
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
-    
+  fParticleChange = GetParticleChangeForGamma();
   isInitialised = true;
 }
@@ -149,4 +146,6 @@
     G4cout << "Calling ComputeCrossSectionPerAtom() of G4LivermorePolarizedComptonModel" << G4endl;
 
+  if (GammaEnergy < lowEnergyLimit || GammaEnergy > highEnergyLimit) return 0.0;
+
   G4double cs = crossSectionHandler->FindValue(G4int(Z), GammaEnergy);
   return cs;
@@ -203,5 +202,4 @@
       fParticleChange->SetProposedKineticEnergy(0.);
       fParticleChange->ProposeLocalEnergyDeposit(gammaEnergy0);
-      // SI - IS THE FOLLOWING RETURN NECESSARY ?
       return;
     }
@@ -210,6 +208,8 @@
 
   // Select randomly one element in the current material
-
-  G4int Z = crossSectionHandler->SelectRandomAtom(couple,gammaEnergy0);
+  //G4int Z = crossSectionHandler->SelectRandomAtom(couple,gammaEnergy0);
+  const G4ParticleDefinition* particle =  aDynamicGamma->GetDefinition();
+  const G4Element* elm = SelectRandomAtom(couple,particle,gammaEnergy0);
+  G4int Z = (G4int)elm->GetZ();
 
   // Sample the energy and the polarization of the scattered photon
@@ -429,4 +429,5 @@
   else
     {
+      gammaEnergy1 = 0.;
       fParticleChange->SetProposedKineticEnergy(0.) ;
       fParticleChange->ProposeTrackStatus(fStopAndKill);
@@ -439,4 +440,11 @@
   G4double ElecKineEnergy = gammaEnergy0 - gammaEnergy1 -bindingE;
 
+  // SI -protection against negative final energy: no e- is created
+  // like in G4LivermoreComptonModel.cc
+  if(ElecKineEnergy < 0.0) {
+    fParticleChange->ProposeLocalEnergyDeposit(gammaEnergy0 - gammaEnergy1);
+    return;
+  }
+ 
   // SI - Removed range test
   
@@ -664,20 +672,3 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-G4double G4LivermorePolarizedComptonModel::GetMeanFreePath(const G4Track& track,
-						      G4double,
-						      G4ForceCondition*)
-{
-  const G4DynamicParticle* photon = track.GetDynamicParticle();
-  G4double energy = photon->GetKineticEnergy();
-  const G4MaterialCutsCouple* couple = track.GetMaterialCutsCouple();
-  size_t materialIndex = couple->GetIndex();
-  G4double meanFreePath;
-  if (energy > highEnergyLimit) meanFreePath = meanFreePathTable->FindValue(highEnergyLimit,materialIndex);
-  else if (energy < lowEnergyLimit) meanFreePath = DBL_MAX;
-  else meanFreePath = meanFreePathTable->FindValue(energy,materialIndex);
-  return meanFreePath;
-}
-
-
+
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedRayleighModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedRayleighModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedRayleighModel.cc	(revision 1055)
@@ -24,7 +24,17 @@
 // ********************************************************************
 //
-// $Id: G4LivermorePolarizedRayleighModel.cc,v 1.1 2008/10/30 14:16:35 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4LivermorePolarizedRayleighModel.cc,v 1.5 2009/05/02 15:20:53 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
+// History:
+// --------
+// 02 May 2009   S Incerti as V. Ivanchenko proposed in G4LivermoreRayleighModel.cc
+//
+// Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+//                  - remove GetMeanFreePath method and table
+//                  - remove initialisation of element selector 
+//                  - use G4ElementSelector
 
 #include "G4LivermorePolarizedRayleighModel.hh"
@@ -38,10 +48,10 @@
 G4LivermorePolarizedRayleighModel::G4LivermorePolarizedRayleighModel(const G4ParticleDefinition*,
                                              const G4String& nam)
-:G4VEmModel(nam),isInitialised(false)
-{
-  lowEnergyLimit = 250 * eV; // SI - Could be 10 eV ?
+:G4VEmModel(nam),isInitialised(false),crossSectionHandler(0),formFactorData(0)
+{
+  lowEnergyLimit = 250 * eV; 
   highEnergyLimit = 100 * GeV;
   
-  SetLowEnergyLimit(lowEnergyLimit);
+  //SetLowEnergyLimit(lowEnergyLimit);
   SetHighEnergyLimit(highEnergyLimit);
   //
@@ -54,9 +64,11 @@
   // 4 = entering in methods
 
-  G4cout << "Livermore Polarized Rayleigh is constructed " << G4endl
+  if(verboseLevel > 0) {
+    G4cout << "Livermore Polarized Rayleigh is constructed " << G4endl
          << "Energy range: "
-         << lowEnergyLimit / keV << " keV - "
+         << lowEnergyLimit / eV << " eV - "
          << highEnergyLimit / GeV << " GeV"
          << G4endl;
+  }
 }
 
@@ -65,6 +77,6 @@
 G4LivermorePolarizedRayleighModel::~G4LivermorePolarizedRayleighModel()
 {  
-  delete crossSectionHandler;
-  delete formFactorData;
+  if (crossSectionHandler) delete crossSectionHandler;
+  if (formFactorData) delete formFactorData;
 }
 
@@ -84,21 +96,10 @@
     G4cout << "Calling G4LivermorePolarizedRayleighModel::Initialise()" << G4endl;
 
-  InitialiseElementSelectors(particle,cuts);
-
-  // Energy limits
-  
-  if (LowEnergyLimit() < lowEnergyLimit)
-    {
-      G4cout << "G4LivermorePolarizedRayleighModel: low energy limit increased from " << 
-	LowEnergyLimit()/eV << " eV to " << lowEnergyLimit << " eV" << G4endl;
-      SetLowEnergyLimit(lowEnergyLimit);
-    }
-  if (HighEnergyLimit() > highEnergyLimit)
-    {
-      G4cout << "G4LivermorePolarizedRayleighModel: high energy limit decreased from " << 
-	HighEnergyLimit()/GeV << " GeV to " << highEnergyLimit << " GeV" << G4endl;
-      SetHighEnergyLimit(highEnergyLimit);
-    }
-    
+  if (crossSectionHandler)
+  {
+    crossSectionHandler->Clear();
+    delete crossSectionHandler;
+  }
+  
   // Read data files for all materials
 
@@ -113,21 +114,22 @@
   formFactorData->LoadData(formFactorFile);
 
+  InitialiseElementSelectors(particle,cuts);
+
   //
   if (verboseLevel > 2) 
     G4cout << "Loaded cross section files for Livermore Polarized Rayleigh model" << G4endl;
 
-  G4cout << "Livermore Polarized Rayleigh model is initialized " << G4endl
+  InitialiseElementSelectors(particle,cuts);
+
+  if (verboseLevel > 0) { 
+    G4cout << "Livermore Polarized Rayleigh model is initialized " << G4endl
          << "Energy range: "
-         << LowEnergyLimit() / keV << " keV - "
+         << LowEnergyLimit() / eV << " eV - "
          << HighEnergyLimit() / GeV << " GeV"
          << G4endl;
+	 }
 
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
-    
+  fParticleChange = GetParticleChangeForGamma();
   isInitialised = true;
 }
@@ -144,4 +146,6 @@
     G4cout << "Calling CrossSectionPerAtom() of G4LivermorePolarizedRayleighModel" << G4endl;
 
+  if (GammaEnergy < lowEnergyLimit || GammaEnergy > highEnergyLimit) return 0.0;
+
   G4double cs = crossSectionHandler->FindValue(G4int(Z), GammaEnergy);
   return cs;
@@ -166,5 +170,4 @@
       fParticleChange->SetProposedKineticEnergy(0.);
       fParticleChange->ProposeLocalEnergyDeposit(photonEnergy0);
-      // SI - IS THE FOLLOWING RETURN NECESSARY ?
       return ;
   }
@@ -173,5 +176,8 @@
 
   // Select randomly one element in the current material
-  G4int Z = crossSectionHandler->SelectRandomAtom(couple,photonEnergy0);
+  // G4int Z = crossSectionHandler->SelectRandomAtom(couple,photonEnergy0);
+  const G4ParticleDefinition* particle =  aDynamicGamma->GetDefinition();
+  const G4Element* elm = SelectRandomAtom(couple,particle,photonEnergy0);
+  G4int Z = (G4int)elm->GetZ();
 
   G4double outcomingPhotonCosTheta = GenerateCosTheta(photonEnergy0, Z);
